#include "stdafx.h"
#include <windows.h>
#include <Commctrl.h>
#include <vector>

#pragma comment(lib, "D:\\VS2010\\WinLIFT64.lib")
#pragma comment(lib, "D:\\VS2010\\WinLIFT32.lib")
#include "WinLIFT.h"
#include "tools.h"

#define IDC_BTN_LEFT     101
#define IDC_BTN_PLAY     102
#define IDC_BTN_RIGHT    103
#define IDC_BTN_CHECK    104
#define IDC_BTN_DELETE   105
#define IDC_BTN_RECYCLE  106
#define IDC_BTN_PRINT    107
#define IDC_BTN_TEXT     108
#define IDC_BTN_SAVE     109
#define IDC_BTN_32BIT    110
#define IDC_BTN_64BIT    111
#define IDC_BTN_00       112
#define IDC_BTN_01       113
#define IDC_BTN_02       114
#define IDC_BTN_03       115
#define IDC_BTN_04       116
#define IDC_BTN_05       117
#define IDC_BTN_06       118
#define IDC_BTN_07       119
#define IDC_BTN_08       120
#define IDC_BTN_09       121
#define IDC_CLOCK        122
#define IDC_FRAME        123
#define IDC_LIPS         124

void AddChildControls(IN HWND hWnd) {
    
    WCHAR zSkinFile[MAX_PATH] = {0}; wcscpy_s(zSkinFile, L"Sony.sks");
    WCHAR zUserKey[MAX_PATH] = {0};

    if (skInitEngine(zSkinFile, zUserKey)) {
        skSkinWindow(hWnd, L"Dock|Undock|Minimize|Maximize|Restore|Close");

        HWND hCtrl;
        wstring sResource = EXEpath(); sResource += L"Resource\\";
        wstring sComponent;
       
        sComponent = sResource; sComponent += L"BTN_Left.png";
        hCtrl = skButtonImage(hWnd, (WCHAR*) sComponent.c_str(), 216-57, 300+12, IDC_BTN_LEFT, 5);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
       
        sComponent = sResource; sComponent += L"BTN_Play.png";
        hCtrl = skButtonImage(hWnd, (WCHAR*) sComponent.c_str(), 216, 300, IDC_BTN_PLAY, 5);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
       
        sComponent = sResource; sComponent += L"BTN_Right.png";
        hCtrl = skButtonImage(hWnd, (WCHAR*) sComponent.c_str(), 216+49, 300+12, IDC_BTN_RIGHT, 5);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
       
       
        sComponent = sResource; sComponent += L"Check_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), L"BS_LEFT", 20, 20, 140, 50, IDC_BTN_CHECK, BS_LEFT | BS_VCENTER);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ);
       
        sComponent = sResource; sComponent += L"Delete_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), L"BS_CENTER", 20 + 140 + 8, 20, 140, 50, IDC_BTN_DELETE, BS_CENTER | BS_VCENTER);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ);
       
        sComponent = sResource; sComponent += L"Recycle_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), L"BS_RIGHT", 20 + (140 + 8) * 2, 20, 140, 50, IDC_BTN_RECYCLE, BS_RIGHT | BS_VCENTER);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ);
       
       
        sComponent = sResource; sComponent += L"Print_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), L"BS_TOP", 20, 20 + 70, 140, 50, IDC_BTN_PRINT, BS_TOP);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
       
        hCtrl = skPushButtonImage(hWnd, L"", L"Arial font", 20 + 140 + 8, 20 + 70, 140, 50, IDC_BTN_TEXT, BS_CENTER | BS_VCENTER);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        skSetLabelFont(hCtrl, L"Arial", 28, skARGB(255, 255,255,0), FontStyleRegular);
       
        sComponent = sResource; sComponent += L"Save_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), L"BS_BOTTOM", 20 + (140 + 8) * 2, 20 + 70, 140, 50, IDC_BTN_SAVE, BS_BOTTOM);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
       
        sComponent = sResource; sComponent += L"00_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 0), 20 + 140, 38, 38, IDC_BTN_00, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"01_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 1), 20 + 140, 38, 38, IDC_BTN_01, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"02_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 2), 20 + 140, 38, 38, IDC_BTN_02, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"03_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 3), 20 + 140, 38, 38, IDC_BTN_03, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"04_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 4), 20 + 140, 38, 38, IDC_BTN_04, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"05_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 5), 20 + 140, 38, 38, IDC_BTN_05, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"06_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 6), 20 + 140, 38, 38, IDC_BTN_06, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"08_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 7), 20 + 140, 38, 38, IDC_BTN_07, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"08_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 8), 20 + 140, 38, 38, IDC_BTN_08, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
        sComponent = sResource; sComponent += L"09_32.png";
        hCtrl = skPushButtonImage(hWnd, (WCHAR*) sComponent.c_str(), NULL, 40 + (40 * 9), 20 + 140, 38, 38, IDC_BTN_09, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_CENTER);
       
        sComponent = sResource; sComponent += L"Clock_08_92.png";
        hCtrl = skClockCtrl(hWnd, (WCHAR*) sComponent.c_str(), 14, 258, 0, 0, IDC_CLOCK, 0x7FCB0000, 0x7F8F8F8F, 0);
        skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM);
       
        if (sizeof(LONG_PTR) == 8) {
            sComponent = sResource; sComponent += L"64bit_80.png"; }
        else {
            sComponent = sResource; sComponent += L"32bit_80.png";
        }
        hCtrl = skButtonImage(hWnd, (WCHAR*) sComponent.c_str(), 380, 264, IDC_BTN_64BIT, 5);
        skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM_RIGHT);
       
        sComponent = sResource; sComponent += L"Aero.png";
        hCtrl = skStaticImage(hWnd, (WCHAR*) sComponent.c_str(), 10, 10, 460, 208, IDC_FRAME);
        skSetZorder(hCtrl, HWND_BOTTOM);
        skSetAnchorCtrl(hCtrl, ANCHOR_HEIGHT_WIDTH);
       
        sComponent = sResource; sComponent += L"makeuplips.png";
        hCtrl = skStaticImage(hWnd, (WCHAR*) sComponent.c_str(), -20, -70, 200, 134, IDC_LIPS);
        skSetZorder(hCtrl, HWND_TOP);
    }
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
    if (uMsg == WM_CREATE) {
        AddChildControls(hWnd);
    }
    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {
    long nRet = 0;
    WNDCLASSEX wcx; MSG msg;
    WCHAR szWindowClass[] = L"BUTTONS";
    wstring sCaption = L"Buttons ";
    if (sizeof(LONG_PTR) == 8) {
        sCaption += L"64-bit"; }
    else {
        sCaption += L"32-bit";
    }
    // Register the main window class
    wcx.cbSize = sizeof(WNDCLASSEX);
    long IsInitialized = GetClassInfoEx(hInstance, szWindowClass, &wcx);
    if (!IsInitialized) {
         wcx.style         = CS_HREDRAW | CS_VREDRAW;
         wcx.lpfnWndProc   = WndProc;
         wcx.cbClsExtra    = 0;
         wcx.cbWndExtra    = 0;
         wcx.hInstance     = hInstance;
         wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
         wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
         wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
         wcx.lpszMenuName  = NULL;
         wcx.lpszClassName = szWindowClass;
         wcx.hIconSm       = wcx.hIcon;
         if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
    }
    if (IsInitialized) {

        DWORD dwExStyle = 0, dwStyle = WS_OVERLAPPEDWINDOW;
        RECT rc; SetRect(&rc, 0, 0, 480, 360);
        AdjustWindowRectEx(&rc, dwStyle, FALSE, dwExStyle);    // Adjust Window To True Requested Size
        int x = max((GetSystemMetrics(SM_CXSCREEN) - rc.right - rc.left) / 2, 0);
        int y = max((GetSystemMetrics(SM_CYSCREEN) - rc.bottom - rc.top) / 2, 0);
        HWND hWnd = CreateWindowEx(
                    dwExStyle,                      // Optional window styles.
                    szWindowClass,                  // Window class
                    (WCHAR*) sCaption.c_str(),      // Window text
                    dwStyle,                        // Window style
                    x, y, rc.right - rc.left, rc.bottom - rc.top,
                    NULL,                           // Parent window    
                    NULL,                           // Menu
                    hInstance,                      // Instance handle
                    NULL                            // Additional application data
                    );
    
        if (hWnd) {

           ShowWindow(hWnd, nCmdShow);
           UpdateWindow(hWnd);

           // Main message loop
           while (GetMessage(&msg, NULL, 0, 0)) {
               TranslateMessage(&msg);
               DispatchMessage(&msg);
           }
           nRet = (long) msg.wParam;
        }

    }

    return nRet;
}

